unit Kurv_u;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

type
  TKurveFormular = class(TForm)
    xFeld: TEdit;
    yFeld: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    Zeichnekopf: TButton;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ZeichnekopfClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  KurveFormular: TKurveFormular;

implementation
{$R *.DFM}

var Einheit:  Integer;
    Ursprung: Record i,j: Integer end;

function f(x: Real): Real;
begin
  f := cos(x);
end;

procedure TKurveFormular.FormActivate(Sender: TObject);
begin
  Einheit := 30;
  With KurveFormular do begin
    Ursprung.i := Width Div 2;  Ursprung.j := (Height-30) Div 2;
    Canvas.Pen.Color := clBlack;
  end;
end;

procedure TKurveFormular.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  xFeld.Text := IntToStr(x);
  yFeld.Text := IntToStr(y);
end;

procedure Achsenzeichnen;
begin
  With KurveFormular do begin
    Canvas.moveto(0,Ursprung.j);  Canvas.lineto(Width,Ursprung.j);
    Canvas.moveto(Ursprung.i,0);  Canvas.lineto(Ursprung.i,Height);
  end;
end;

procedure KurveZeichnen;
var i,j: Integer;
    x,y: Real;
begin
  With KurveFormular do begin
    i := 0;   x := (i - Ursprung.i) / Einheit;
    y := f(x);
    j := -round(y*Einheit) + Ursprung.j;
    canvas.moveto(i,j);
    for i := 1 to Width do begin
      x := (i - Ursprung.i) / Einheit;
      y := f(x);
      j := -round(y*Einheit) + Ursprung.j;
      canvas.lineto(i,j);
    end;
  end;
end;

procedure TKurveFormular.ZeichnekopfClick(Sender: TObject);
begin
  Achsenzeichnen;
  KurveZeichnen;
end;

end.
